#pragma once

#include "camera.h"
#include "ray.h"
#include "vec2i.h"
#include "vec3f.h"
#include "vec4f.h"
#include "viewport.h"

namespace openGL {

math::Vec3f unprojectToWorld(math::Vec2i const &pixelPosition,
                             scene::Camera const &camera,
                             rendering::Viewport const &viewport);

math::Vec4f perspectiveDivide(math::Vec4f v);

math::geometry::Ray rayFromPixelPosition(math::Vec2i const &pixelPosition,
                                         scene::Camera const &camera,
                                         rendering::Viewport const &viewport);

} // namespace openGL
