#pragma once

#include <optional>

#include "ray.h"
#include "vec3f.h"

namespace math {
namespace geometry {

struct Plane {
  math::Vec3f m_origin = {0.f, 0.f, 0.f};
  math::Vec3f m_normal = {0.f, 0.f, 1.f}; // defaults to z-axis

  Plane() = default;
  Plane(Vec3f origin);
  Plane(Vec3f origin, Vec3f direction);
};

std::optional<Ray::Intersection>
intersectRayPlane(math::Vec3f const &planeOrigin,
                  math::Vec3f const &planeNormal, math::Vec3f const &rayOrigin,
                  math::Vec3f const &rayDirection, float epsilon);
std::optional<Ray::Intersection> intersect(Plane const &plane, Ray const &ray,
                                           float epsilon);

} // namespace geometry
} // namespace math
