#pragma once

#include "vec3f.h"

namespace math {
namespace geometry {

struct Ray {
  Vec3f m_origin = {0.f, 0.f, 0.f};
  Vec3f m_direction = {0.f, 0.f, 1.f}; // defaults to z-axis

  Ray() = default;
  Ray(Vec3f origin);
  Ray(Vec3f origin, Vec3f direction);

  struct Intersection {
    Intersection() = default;
    Intersection(float t, Vec3f position);

    float t = 0.f;
    Vec3f position = {0.f, 0.f, 0.f};
  };
};

} // namespace geometry
} // namespace math
