#pragma once

#include <vector>

#include "axisbuffer.h"
#include "curvebuffer.h"
#include "program.h"

namespace openGL {
namespace rendering {

class ResourceManager {
public:
  ResourceManager();

  // Shader program
  openGL::rendering::Program &getProgram(int idx);
  int pushProgram(openGL::rendering::Program &&program);
  size_t programCount() const;

  // Curver VBO
  openGL::rendering::CurveBuffer &getCurveBuffer(int idx);
  int pushCurveBuffer(openGL::rendering::CurveBuffer &&curveBuffer);
  size_t curveBufferCount() const;

  // Axis VBO
  openGL::rendering::AxisBuffer &getAxisBuffer(int idx);
  int pushAxisBuffer(openGL::rendering::AxisBuffer &&axisBuffer);
  size_t axisBufferCount() const;

  //... seeing a trend yet?

  void clear();

private:
  std::vector<openGL::rendering::Program> m_program;
  std::vector<openGL::rendering::CurveBuffer> m_curveBuffer;
  std::vector<openGL::rendering::AxisBuffer> m_axisBuffer;
};

} // namespace rendering
} // namespace openGL
