#pragma once

#include <iosfwd>
namespace math {

struct Vec2i {
public:
  union {
    struct {
      int m_x, m_y;
    };
    int m_coord[2] = {0, 0};
  };

  Vec2i() = default;
  Vec2i(int x, int y);

  int &operator[](int idx);
  int const &operator[](int idx) const;

  // usefull operators //

  Vec2i &operator+=(Vec2i const &other);
  Vec2i &operator-=(Vec2i const &other);
  Vec2i &operator*=(int factor);
  Vec2i &operator/=(int other);

  int *data();
  int const *data() const;
};

// Free function declarations
Vec2i operator+(Vec2i const &a, Vec2i const &b);
Vec2i operator-(Vec2i const &a, Vec2i const &b);
Vec2i operator*(Vec2i const &v, int s);
Vec2i operator*(int s, Vec2i const &v);
Vec2i operator-(Vec2i v);

float norm(Vec2i const &v);
float normSquared(Vec2i const &v);

float distance(Vec2i const &a, Vec2i const &b);
float distanceSquared(Vec2i const &a, Vec2i const &b);

float operator*(Vec2i const &a, Vec2i const &b);
float dotProduct(Vec2i const &a, Vec2i const &b);

bool operator<(Vec2i const &a, Vec2i const &b);

std::ostream &operator<<(std::ostream &out, Vec2i const &vec);
std::istream &operator>>(std::istream &in, Vec2i &vec);

} // namespace math
